%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% FUNCTION: [fx, gradfx, qx_out, px_out] = scopt_logistic_fx_eval(x, ...
%%%                              Ax, What, bhat, N, yhat, NWThat, isFxEval) 
%%% PURPOSE:  Evaluate the objective value/gradient of the function.
%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function fx = logistic_fx_eval(x, What, bhat, N, yhat, isFxEval) 

NWThat   = What'/N;
Ax = (What*x).*yhat + bhat;
expAx = exp(-Ax);

% Evaluate the objective value.
if isFxEval == true
    fx = (1/N)*sum( log(1 + expAx) );
else
% Evaluate the gradient.
    px     = 1./(1 + expAx) - 1;
    ypx    = yhat.*px;
    fx     = NWThat*ypx;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% END OF THE IMPLEMENTATION.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%